// Gateway Library Parent 
#include <stdio.h> 
#include <windows.h> 
 
#define BUFSIZE 8192 
 
HANDLE hReadTerminal, hWriteTerminal,
       hReadSocket, hWriteSocket;
char  chBuf[BUFSIZE];
DWORD  retval;
DWORD dwRead, dwWritten; 
BOOL fSuccess; 
 
char * CreateChildProcess(char * argv); 
VOID   ErrorExit(LPTSTR); 
char * PipeAndProcessCreation();
char * GlpToII(char * argv);
char * IIToGlp(char * argv);

BOOL     CALLBACK    TraceFileWriting(LPSTR       lpData1);

char * String;

void __cdecl DllMain() 
{ 
} 
char * PipeAndProcessCreation(char * argv){
    SECURITY_ATTRIBUTES saAttr;
    SECURITY_ATTRIBUTES saAttr2;
    char  * StringForSocket = HeapAlloc(GetProcessHeap(), 
                                        HEAP_ZERO_MEMORY, 
                                        25
                                        );
    char  * String          = HeapAlloc(GetProcessHeap(), 
                                        HEAP_ZERO_MEMORY, 
                                        25
                                        );
    saAttr.nLength = sizeof(SECURITY_ATTRIBUTES); 
    saAttr.bInheritHandle = TRUE; 
    saAttr.lpSecurityDescriptor = NULL; 
    saAttr2.nLength = sizeof(SECURITY_ATTRIBUTES); 
    saAttr2.bInheritHandle = TRUE; 
    saAttr2.lpSecurityDescriptor = NULL; 

    CreatePipe(&hReadTerminal, &hWriteSocket, &saAttr, 0);

    CreatePipe(&hReadSocket, &hWriteTerminal, &saAttr2, 0); 

    sprintf(StringForSocket, "%d", hReadSocket);
    strcat(StringForSocket, " ");
    sprintf(String, "%d", hWriteSocket);
    strcat(StringForSocket, String);
    strcat(StringForSocket, " ");
    strcat(StringForSocket, argv);
    //////////////////////////////////////////////////
    //    TraceFileWriting((LPSTR)String);
    //////////////////////////////////////////////////
    strcat(StringForSocket, " ");
    sprintf(String, "%d", hReadTerminal);
    strcat(StringForSocket, String);
    strcat(StringForSocket, " ");
    sprintf(String, "%d", hWriteTerminal);
    strcat(StringForSocket, String);
    String = CreateChildProcess(StringForSocket);
    if (strcmp(String, "child process is created") != 0) 
      return (String);

    CloseHandle(hReadSocket);
    CloseHandle(hWriteSocket);

    return(GlpToII(""));
}
char * GlpToII(char * argv){
    String = HeapAlloc(GetProcessHeap(), 
                       HEAP_ZERO_MEMORY, 
                       BUFSIZE
                       );

    SecureZeroMemory(String, BUFSIZE);

    fSuccess = ReadFile(hReadTerminal, String, BUFSIZE, &dwRead, NULL); 
    if (! fSuccess || dwRead == 0){ 
      sprintf(String, "GlpToII failed: %d with handle: %d\n", GetLastError(),hReadTerminal);
      return (String);
    }
    return(String);
}
char * IIToGlp(char * argv){
    fSuccess = WriteFile(hWriteTerminal, argv, strlen(argv), &dwWritten, NULL); 
    if (! fSuccess) 
       return ("IIToGlp failed");
    return ("IIToGlp succed");       
}
 
char * CreateChildProcess(char * argv) { 
    PROCESS_INFORMATION piProcInfo; 
    STARTUPINFO siStartInfo;
    LPTSTR lpBuffer;
    LPTSTR* lpFilePart;
    DWORD funres;
    DWORD nBufferLength=130;
    BOOL bFuncRetn = FALSE; 
    char * retstr = HeapAlloc(GetProcessHeap(), 
                              HEAP_ZERO_MEMORY, 
                              140
                              );

    lpBuffer = HeapAlloc(GetProcessHeap(), 
                              HEAP_ZERO_MEMORY, 
                              nBufferLength
                              );

    lpFilePart = HeapAlloc(GetProcessHeap(), 
                              HEAP_ZERO_MEMORY, 
                              nBufferLength
                              );

    ZeroMemory( &piProcInfo, sizeof(PROCESS_INFORMATION) );
    ZeroMemory( &siStartInfo, sizeof(STARTUPINFO) );
    siStartInfo.cb = sizeof(STARTUPINFO); 
    funres = SearchPath(
      NULL,
      "glc",
      ".exe",
      nBufferLength,
      lpBuffer,
      lpFilePart);
    if(funres == 0)sprintf(lpBuffer,"%d",GetLastError());
    
    bFuncRetn = CreateProcess(lpBuffer,                /*"D:\\WINDDK\\2600~1.110\\src\\po\\m\\gl\\glc\\objfre_wxp_x86\\i386\\*/ // command line 
      argv,
      NULL, 
      NULL, 
      TRUE, 
      0, 
      NULL, 
      NULL, 
      &siStartInfo, 
      &piProcInfo);
   
    if (bFuncRetn == 0) {
      retval = GetLastError();
      sprintf(retstr, "%d",  retval); 
      strcat(retstr," :: ");
      strcat(retstr,lpBuffer);
      return(retstr);
    } else {
      CloseHandle(piProcInfo.hProcess);
      CloseHandle(piProcInfo.hThread);
      return ("child process is created");
    }
}

 
 
VOID ErrorExit (LPTSTR lpszMessage) { 
  fprintf(stderr, "%s\n", lpszMessage); 
  HeapFree(GetProcessHeap(), 
           0, 
           String
           );
  ExitProcess(0); 
} 
BOOL     CALLBACK    TraceFileWriting(LPSTR       lpData1){
  DWORD lpNumberOfBytesWritten;
  LPCTSTR lpFileName;
  HANDLE OpenFileHandle;
  int LenghtOfString;
  lpFileName ="d:\\TraceFileWritingParent.txt"; 			
  OpenFileHandle = CreateFile(
			lpFileName,
			GENERIC_WRITE | GENERIC_READ,
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			NULL,
			CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,
			NULL);
	SetFilePointer(
			OpenFileHandle,
			0,
			NULL,
			FILE_BEGIN
			);	
    LenghtOfString = strlen(lpData1);
	WriteFile(OpenFileHandle,
			lpData1,
			LenghtOfString,
			&lpNumberOfBytesWritten,
			NULL);
	CloseHandle(OpenFileHandle);
	return TRUE;
}
