// Graphic module
import javax.microedition.lcdui.*;

public class Candles extends Canvas {
    Display             display;
    Displayable         da;
    AlertType           alertType = AlertType.ALARM;
    public static float mini,
                        maxi,
                        minv,
                        maxv,
                        differencev,
                        difference,
                        bid,
                        f;
    int                 h3,
                        shift      = 0,
                        cQ         = 41,
                        width,
                        height,
                        slash,
                        p,
                        x,
                        y,
                        w,
                        h,
                        h4,
                        w3,
                        w4,
                        yy,
                        index,
                        pOI;
    Font                font;
    float               dM[][]     = new float [cQ][6],
                        cP;
    int                 candle[]   = new int[5];
    String              TST,
                        EXC,
                        iHH, 
                        url,
                        IID,
                        PID,
                        iH         = new String(),
                        mk;
    Graphics            g;
    boolean             openTrue   = true,
                        pnp, 
                        setValue   = false,
                        ExceptionTrue = false;
    Runtime             r;
    Ticker              ticker;
    StringBuffer        tString;
  public Candles (Display d, StringBuffer tickerString){

    //setFullScreenMode(true);

                        display    = d;
                        r          = Runtime.getRuntime();
                        tString = tickerString;
  }
  protected void paint(Graphics g) {
                        this.g     = g;
                        x          = g.getClipX();
                        y          = g.getClipY();
                        w          = getWidth();
                        h          = getHeight();
                        h4         = h/3*2*120/100;
                        w3         = w/cQ + 1;
                        if (w < 133){
                          w3 = 4;
                          w4 = 1;
                        }
                        else{
                          w3 = 6;
                          w4 = 2;
                        }
                        h3         = h/3*2*90/100;

    g.setColor(0xffffff);
    g.fillRect(x,y,w,h);
    try{
      if (pnp == true){
        index = 0;
        iH = new String(iHH);
        pOI = iH.length();
        for (int i=0; i<cQ; i++){
          try{
            index = iH.indexOf("t",index) +1; 
            dM[i][0]=Float.parseFloat(iH.substring(index,iH.indexOf("o",index)-1)); 
            index = iH.indexOf("o",index) +1; 
            dM[i][1]=Float.parseFloat(iH.substring(index,iH.indexOf("l",index)-1)); 
            index = iH.indexOf("l",index) +1;
            dM[i][2]=Float.parseFloat(iH.substring(index,iH.indexOf("h",index)-1)); 
            index = iH.indexOf("h",index) +1;
            dM[i][3]=Float.parseFloat(iH.substring(index,iH.indexOf("c",index)-1));
            index = iH.indexOf("c",index) +1;
            dM[i][4]=Float.parseFloat(iH.substring(index,iH.indexOf("v",index)-1)); 
            index = iH.indexOf("v",index) +1;
            dM[i][5]=Float.parseFloat(iH.substring(index,iH.indexOf("/",index)-1));
            if (i > 0){
              if (dM[i][2] < mini)  mini = dM[i][2];         
              if (dM[i][3] > maxi)  maxi = dM[i][3];
              if (dM[i][5] < minv)  minv = dM[i][5]; 
              if (dM[i][5] > maxv)  maxv = dM[i][5];
            }else{
              mini = dM[i][2];          
              maxi = dM[i][3];       
              minv = dM[i][5];
              maxv = dM[i][5];
            }
          }catch (Exception e){
            index = iH.indexOf("v",index) +1;
            continue;
          }
        }
      } 
      difference = (maxi - mini);
      shift = w - cQ * w3;
      for (int i = cQ-1; i > -1; i--){
        for (int j = 0; j < 4; j++){ 
          f = (float)((maxi - dM[i][j+1])/difference*100);
          candle[j] = (int)(h3*f/100);
        }      
        f = (float)(100 - dM[i][5]/maxv*100);
        candle[4] = (int)((h-h4)*f/100+h4);
        if (candle[3]>candle[0]){
          g.setColor(0xFF0000);
          g.fillRect(i*w3+shift,candle[0],w3-1,candle[3]-candle[0]);
        }else {
          g.setColor(0x0000FF);
          g.fillRect(i*w3+shift,candle[3],w3-1,candle[0]-candle[3]);
        }
        g.fillRect((i*w3)+shift+w4,candle[2],1,candle[1]-candle[2]);
        g.setColor(0x00FF00);
        g.fillRect((i*w3)/*+3*/+shift,candle[4],w3-1,h -candle[4]);
      }
      if (pnp == false){ 
          g.setColor(0x000000);
          font = Font.getFont(Font.FACE_PROPORTIONAL, 
                           Font.STYLE_PLAIN, 
                           Font.SIZE_SMALL);
          g.setFont(font);
          if (!ExceptionTrue){
            TST = ("Up: " + Float.toString(maxi) +
                   " Down: " + Float.toString(mini) + " (bid)");
            g.drawString(IID + " " +
                   iHH.substring(iHH.indexOf("c")+1,iHH.indexOf("/")) +
                   " Gap: " +
                   PID + " min",1,h3+1,0);
            bid = Float.parseFloat(iHH.substring(iHH.indexOf("c")+1,iHH.indexOf("/")));
            f = (float)((maxi - bid)/difference*100);
            yy = (int)(h3*f/100);
            g.setStrokeStyle(g.DOTTED);
            g.drawLine(1,yy,w-1,yy);
          } else {
            TST = EXC;
            g.drawString(TST.substring(TST.length()/2),1,h3+1,0);
          }
          g.drawString(TST,1,h3+13,0);
      }
    }catch (Exception e){
       Alert a = new Alert("MTT2",e.toString()+"::"+mk+"::"+TST+"::"+EXC, null, AlertType.ERROR);
       a.setTimeout(Alert.FOREVER);
       display.setCurrent(a);
       display.vibrate(100);
    }
    System.gc();
  }  
  protected void showNotify(){
          repaint();
  }
  public synchronized String start(String ih, boolean or, String iid, String pid) {
    String response = new String();
    try{
      if (!openTrue)
        try {
          wait();
        }catch(InterruptedException e){
          EXC = "Candles: "  + e.toString();
          ExceptionTrue = true;
        } 
        openTrue = false;
        pnp = or;
        if (pnp == true){
          IID = iid;
          PID = pid;
        }
        if (ih.substring(0,1).equals("t")== true){
          iHH = ih;
          ExceptionTrue = false;
          response = "all right";
          if(pnp == false){   
            cP = Float.parseFloat(ih.substring(1,ih.indexOf("c")-1));
            if (dM[cQ-1][0] == cP){
              cP = Float.parseFloat(ih.substring(ih.indexOf("c")+1,ih.indexOf("/")-1));
              dM[cQ-1][4] = cP;
              if (dM[cQ-1][2] > cP){
                dM[cQ-1][2]  = cP;
                if (dM[cQ-1][2] < mini)  mini = dM[cQ-1][2];
              }
              if (dM[cQ-1][3] < cP){
                dM[cQ-1][3]  = cP;
                if (dM[cQ-1][3] > maxi)  maxi = dM[cQ-1][3];
              }
            }else{
              cP = Float.parseFloat(ih.substring(ih.indexOf("c")+1,ih.indexOf("/")-1));
              for (int i=0; i<(cQ-1); i++){
                for (int j=0;j<6; j++) {
                  dM[i][j] =dM[i+1][j]; 
                }
              }
              dM[cQ-1][0] = Float.parseFloat(ih.substring(1,ih.indexOf("c")-1)); 
              for (int u=1;u<6; u++) dM[cQ-1][u] = cP;
            }
          }
        }else{
          EXC = ih;
          ExceptionTrue = true;
          response = "panic :: " + EXC;
        }
        if ((da = display.getCurrent()) == this){
          repaint();
          display.setCurrent(this);
        }
      openTrue = true;
      notify();
    }catch(Exception e){       
       Alert a = new Alert("MTT", e.getMessage() + " :$: " + ih, null, AlertType.ERROR);
       a.setTimeout(Alert.FOREVER);
       display.setCurrent(a);
    }
    return(response);
  }
}
